#pragma region Copyright 2012 IPETRONIK GmbH & Co.KG
//
// All rights are reserved. Reproduction or transmission in whole or in part, in
// any form or by any means, electronic, mechanical or otherwise, is prohibited
// without the prior written consent of the copyright owner.
//
// KGI
//
#pragma endregion
/// <summary>
/// ExtensionDllTypes.h
/// </summary>
#pragma once

/// <summary>
/// Value definitions
/// </summary>
#define NO_SYSTEM 0
#define NO_PACKET 0

/// <summary>
/// define
/// </summary>
#define _WIN32_WINNT 0x0501
#define WIN32_LEAN_AND_MEAN

/// <summary>
/// include
/// </summary>
#include <windows.h>
#include <float.h>

/// <summary>
/// Typ-Definitionen
/// </summary>
typedef int					BOOL;
typedef unsigned char		UCHAR;
typedef unsigned short		USHORT;
typedef signed long			LONG;
typedef unsigned long		ULONG;
typedef wchar_t				WCHAR;
typedef HRESULT				HRESULT;

#define MAX_WCHAR			256
#define MAX_WCHAR_PATH		512

/// <summary>
/// Definitionen
/// </summary>
#define EXTENSION_API		__stdcall
#define EXTENSION_EXPORT	__declspec(dllexport)

/// <summary>
/// Callback function type definitions
/// </summary>
typedef HRESULT (EXTENSION_API * PFN_EXT_SET_PACKET_DATA_FLOAT64_FUNC)(	ULONG ulSystemIdentifier,
																		ULONG ulPacketIdentifier,
																		double dDataFloat64);
typedef HRESULT (EXTENSION_API * PFN_EXT_SEND_DATA_FUNC)(	ULONG ulSystemIdentifier,
															LONG lDataSize,
															UCHAR* paucData);
typedef LONG    (EXTENSION_API * PFN_EXT_READ_INPUT_BUFFER)(ULONG ulSystemIdentifier,
															LONG lBufferSize,
															UCHAR* paucBuffer,
															LONG* plReadBytesCount);
typedef HRESULT (EXTENSION_API * PFN_EXT_RESET_INPUT_BUFFER)(ULONG ulSystemIdentifier);
typedef HRESULT (EXTENSION_API * PFN_EXT_TRACE_MESSAGE)(WCHAR *wszTrace);

/// <summary>
/// Dll function type definitions
/// </summary>
typedef HRESULT (EXTENSION_API * ExtInitDriverProc)(WCHAR* pwszErrorMessage);
typedef HRESULT (EXTENSION_API * ExtExitDriverProc)(WCHAR* pwszErrorMessage);

typedef HRESULT (EXTENSION_API * ExtSetCallbacksProc)(	PFN_EXT_SET_PACKET_DATA_FLOAT64_FUNC pfnDataFloat64,
														PFN_EXT_SEND_DATA_FUNC               pfnSendData,
														PFN_EXT_READ_INPUT_BUFFER            pfnReadInputBuffer,
														PFN_EXT_RESET_INPUT_BUFFER           pfnResetInputBuffer,
														PFN_EXT_TRACE_MESSAGE                pfnTraceInformation,
														PFN_EXT_TRACE_MESSAGE                pfnTraceWarning,
														PFN_EXT_TRACE_MESSAGE                pfnTraceError);
typedef HRESULT (EXTENSION_API * ExtPrepareAcquisitionProc)(	ULONG ulSystemIdentifier);
typedef HRESULT (EXTENSION_API * ExtDoPreAcquisitionTimerProc)(	ULONG ulSystemIdentifier);
typedef HRESULT (EXTENSION_API * ExtDoPostAcquisitionTimerProc)(ULONG ulSystemIdentifier);
typedef HRESULT (EXTENSION_API * ExtFinishAcquisitionProc)(		ULONG ulSystemIdentifier);

