#pragma region Copyright 2012 IPETRONIK GmbH & Co.KG
//
// All rights are reserved. Reproduction or transmission in whole or in part, in
// any form or by any means, electronic, mechanical or otherwise, is prohibited
// without the prior written consent of the copyright owner.
//
// KGI
//
#pragma endregion
/// <summary>
/// Extension.h
/// </summary>
#pragma once
/// <summary>
/// Includes
/// </summary>

#if defined(_DEBUG)
    #define ACTIVATE_MEMORY_LEAK_DETECTION
#endif // _DEBUG

#if defined(ACTIVATE_MEMORY_LEAK_DETECTION)
//
// IMPORTANT the order of include ifles must not be changed! (cf. MS help)
// source: http://msdn.microsoft.com/en-us/library/x98tx3cf.aspx
//
#define _CRTDBG_MAP_ALLOC // adds filename / line number information in output message

#include <stdlib.h>
#include <crtdbg.h>

#if !defined(DBG_NEW)           // for output of file name and line number, the new operator has to be redefined!
    #define DBG_NEW new ( _NORMAL_BLOCK , __FILE__ , __LINE__ )
    #define new DBG_NEW
#endif // DBG_NEW

#endif // ACTIVATE_MEMORY_LEAK_DETECTION

//
// include API header
#include "..\External\Include\ExtensionDllTypes.h"

//
// include windows header
#include <windows.h>
#include <process.h>
#include <vector>

//
// assign some level 4 warnings the level 3 such that the compiler will issue them
//#pragma warning ( 3 : 4100 ) // C4100: "'identifier' : unreferenced formal parameter"
#pragma warning ( 3 : 4189 ) // C4189: "'identifier' : local variable is initialized but not referenced "
#pragma warning ( 3 : 4244 ) // C4244: "'variable' : conversion from 'type' to 'type', possible loss of data"
#pragma warning ( 3 : 4480 ) // C4485: "nonstandard extension used: specifying underlying type for enum 'enum'" : An extension to the language under /clr was used without /clr.
//#pragma warning ( 3 : 4512 ) // C4512 (Level 4): "'class' : assignment operator could not be generated": eg. when class contains const elements, those elements can only be assigned by an explicit defined operator
#pragma warning ( 3 : 4700 ) // C4700: "uninitialized local variable 'name' used"
#pragma warning ( 3 : 4701 ) // C4701: "Potentially uninitialized local variable 'name' used"
#pragma warning ( 3 : 4702 ) // C4702: "unreachable code": eg. extern "C" methods don't throw exceptions! compilation with /EHa is needed

/// <summary>
/// Global member: Dll related data (defined in Serial.Acquisition.Extension.cpp)
/// </summary>
extern HINSTANCE                    g_hResource;

extern UINT16                       g_usVersionMajor;
extern UINT16                       g_usVersionMinor;
extern UINT16                       g_usVersionRevision;
extern UINT16                       g_usVersionBuild;

/// <summary>
/// Global member: callback functions (defined in Extension.cpp)
/// </summary>
extern PFN_EXT_SET_PACKET_DATA_FLOAT64_FUNC g_pfnDataFloat64;
extern PFN_EXT_SEND_DATA_FUNC               g_pfnSendData;
extern PFN_EXT_READ_INPUT_BUFFER            g_pfnReadInputBuffer;
extern PFN_EXT_RESET_INPUT_BUFFER           g_pfnResetInputBuffer;

extern PFN_EXT_TRACE_MESSAGE                g_pfnTraceInformation;
extern PFN_EXT_TRACE_MESSAGE                g_pfnTraceWarning;
extern PFN_EXT_TRACE_MESSAGE                g_pfnTraceError;

//
// include project header
#include "Resource.h"
#include "ExtensionAuxiliaryFunctions.h"
