#pragma region Copyright 2012 IPETRONIK GmbH & Co.KG
//
// All rights are reserved. Reproduction or transmission in whole or in part, in
// any form or by any means, electronic, mechanical or otherwise, is prohibited
// without the prior written consent of the copyright owner.
//
// KGI
//
#pragma endregion

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// ExtensionAuxiliaryFunctions.cpp: defines some auxiliary functions to keep mandatory code
///                                  out of Extension.cpp where the individual code will be placed
/// </summary>

///////////////////////////////////////////////////////////////////////////////////////////
/// 
/// include
/// 
#include "Extension.h"

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// Assignment of callback functions
/// </summary>
HRESULT DoSetCallbacks(	PFN_EXT_SET_PACKET_DATA_FLOAT64_FUNC pfnDataFloat64,
                        PFN_EXT_SEND_DATA_FUNC               pfnSendData,
                        PFN_EXT_READ_INPUT_BUFFER            pfnReadInputBuffer,
                        PFN_EXT_RESET_INPUT_BUFFER           pfnResetInputBuffer,
                        PFN_EXT_TRACE_MESSAGE                pfnTraceInformation,
                        PFN_EXT_TRACE_MESSAGE                pfnTraceWarning,
                        PFN_EXT_TRACE_MESSAGE                pfnTraceError)
{
	HRESULT RetVal = NO_ERROR;

	// Set callback functions for:

	// - transmitting packet / channel data to the plugin
	g_pfnDataFloat64      = pfnDataFloat64;

	// - sending data via the systems COM port
	g_pfnSendData         = pfnSendData;

	// - reading last received input data
	g_pfnReadInputBuffer  = pfnReadInputBuffer;

	// - resetting input data buffer
	g_pfnResetInputBuffer = pfnResetInputBuffer;

	// - setting an information message to the trace log
	g_pfnTraceInformation = pfnTraceInformation;

	// - setting an warning message to the trace log
	g_pfnTraceWarning     = pfnTraceWarning;

	// - setting an error message to the trace log
	g_pfnTraceError       = pfnTraceError;

	return RetVal;
}

///////////////////////////////////////////////////////////////////////////////////////////
